public class Bruch {

    private int z, n;

    public void setZaehler(int zaehler) {
        z = zaehler;
    }

    public void setNenner(int nenner) {
        n = nenner;
    }

    public Bruch multiply(Bruch other) {
        Bruch ergebnis = new Bruch();
        ergebnis.z = z * other.z;
        ergebnis.n = n * other.n;
        return ergebnis;
    }

    public Bruch add(Bruch other) {
        Bruch ergebnis = new Bruch();
        ergebnis.z = z * other.n +
                     other.z * this.n;
        ergebnis.n = n * other.n;
        return ergebnis;
    }

    public void cancel() {
        int a = z;
        int b = n;
        while (b > 0) {
            int r = a % b;
            a = b;
            b = r;
        }
        z /= a;
        n /= a;
    }

    public String toString() {
        return "("+z+"/"+n+")";
    }

    public static void main(String[] argv) {
        Bruch a = new Bruch();
        a.setZaehler(IO.readInt());
        a.setNenner(IO.readInt());
        System.out.println(a);
        Bruch b = a.multiply(a);
        System.out.println(b);
        Bruch c = a.add(b);
        System.out.println(c);
        c.cancel();
        System.out.println(c);
    }

}
